/* WP Slide-up box front end scripts */

jQuery(document).ready(function($){

	var animation_options = { duration: 400 };

	function wpsub_init() {
		$('.wpsub-boxgrid').each(function(){

			var iheight = $( '.wpsub-background', this ).height();
			var iwidth = $( '.wpsub-background', this ).width();
			var	stopx = $( '.slideup_title', this ).outerHeight();

			$( '.cover', this ).css( { width: iwidth + 'px' } );

			$(this).not('.wpsub-clicked').each(function(){
				$( '.bottom-up-full', this ).css( { top: iheight + 'px' } );
				$( '.bottom-up-part', this ).css( { top: (iheight - stopx) + 'px' } );
				$( '.top-down-part', this ).css( { top: (stopx - iheight) + 'px' } );
				$( '.top-down-part .slideup_desc', this ).css( { bottom: (stopx + 20) + 'px' } );
				$( '.left-right', this ).css( { left: -iwidth + 'px' } );
				$( '.left-right-uncover', this ).css( { left: '0px' } );
				$( '.right-left', this ).css( { left : iwidth + 'px' } );
				$( '.right-left-uncover', this ).css( { left: '0px' } );
				$( '.fade-in', this ).css( { display: 'none' } );
				$( '.top-down-full', this ).css( { top: -iheight + 'px' } );
			});

		});
	}

	// Initial settings
	$( window ).load( function() {
		wpsub_init();
	});

	// Fix widths when resizing the window
	$( window ).resize( function() {
		wpsub_init();
	});


	// The animation for hover or first click on mobile version
	function wpsub_animation_part_one( paramThis ) {

		var iheight = $( '.wpsub-background', paramThis ).height();
		var iwidth = $( '.wpsub-background', paramThis ).width();
		var	stopx = $( '.slideup_title', paramThis ).outerHeight();

		$('.bottom-up-full', paramThis).animate( { top: '0px' }, animation_options );
		$('.bottom-up-part', paramThis).animate( { top: '0px' }, animation_options );
		$('.left-right', paramThis).animate( { left: '0px' }, animation_options);
		$('.left-right-uncover', paramThis).animate( { left: iwidth + 'px' }, animation_options);
		$('.right-left', paramThis).animate( { left: '0px' }, animation_options );
		$('.right-left-uncover', paramThis).animate( { left: -iwidth + 'px' }, animation_options );
		$('.fade-in', paramThis).fadeIn( animation_options );
		$('.fade-out', paramThis).fadeOut( animation_options );
		$('.top-down-full', paramThis).animate( { top: '0px' }, animation_options );
		$('.top-down-part', paramThis).animate( { top: '0px' }, animation_options );

	}


	// Get back the initialized position
	function wpsub_animation_part_two( paramThis ) {

		var iheight = $( '.wpsub-background',  paramThis ).height();
		var iwidth = $( '.wpsub-background',  paramThis ).width();
		var	stopx = $( '.slideup_title',  paramThis ).outerHeight();

		$('.bottom-up-full', paramThis).animate( { top: iheight + 'px' }, animation_options );
		$('.bottom-up-part', paramThis).animate( { top: (iheight - stopx) + 'px' }, animation_options );
		$('.left-right', paramThis).animate( { left: -iwidth + 'px' }, animation_options );
		$('.left-right-uncover', paramThis).animate( { left: '0px' }, animation_options );
		$('.right-left', paramThis).animate( { left : iwidth + 'px' }, animation_options );
		$('.right-left-uncover', paramThis).animate( { left: '0px' }, animation_options );
		$('.fade-in', paramThis).fadeOut( animation_options );
		$('.fade-out', paramThis).fadeIn( animation_options );
		$('.top-down-full', paramThis).animate( { top: -iheight + 'px' }, animation_options );
		$('.top-down-part', paramThis).animate( { top: (stopx - iheight) + 'px' }, animation_options );

	}


	// Try to detect touchscreens
	function wpsub_is_touch_device() {
		return 'ontouchstart' in window || navigator.maxTouchPoints;
	};


	// Mobile version
	if ( wpsub_is_touch_device() ) {

		$( '.wpsub-target div').unwrap();

		// Click effect.
		$( '.wpsub-boxgrid' ).on( 'click', function(e) {

			// If clicking outside the wpsub-target-mobile link, don't go to the link target
			if ( !$(e.target).is('.wpsub-target-mobile') ) {
				e.preventDefault();
			}

			var link = $(this).find( '.wpsub-target-mobile' );

			// Second click
			if ( $(this).is('.wpsub-clicked') ) {

				wpsub_animation_part_two( this );
				link.fadeOut();
				$(this).removeClass('wpsub-clicked');

			}

			// First click
			else {

				wpsub_animation_part_one( this );
				setTimeout( function() {
					link.fadeIn();
				}, 380);
				$(this).addClass('wpsub-clicked');

			}

		});

	}

	// Desktop version
	else {

		// Hover effect
		$( '.wpsub-boxgrid' ).hover( function() {

			wpsub_animation_part_one( this );

		}, function() {

			wpsub_animation_part_two( this );

		});

	}

});
